clc;
clear all;
close all;

%% for exangeable Dirichlet distribution
d         = 10; % dimension of the simplex 
w_plot    = 3;
h_plot    = 4;
nr_sample = w_plot*h_plot;

% alphas = [0.001 0.01 0.1 0.5 1 2 5 10 100 1000];
alphas = [0.0001];

%% Set alpha 
for alpha = alphas;
    alpha_vec = alpha*ones(1, d);

    %% Draw samples 
    theta = sample_dirichlet(alpha_vec, nr_sample);

    %% Plot
    fig1 = figure();
    for s = 1:nr_sample 
        subplot(w_plot, h_plot, s);
        stem(0:9, theta(s, :), 'bo');
        if alpha >= 1
            axis([0 9 0 2/d]);
        end
        title(['alpha = ' num2str(alpha)]);
    end
    set(fig1,'PaperPositionMode','auto')
    print (fig1 , '-dpng', ['pics/alpha_', num2str(alpha), '.png']) ;
	pause(.2);
end

%%
close all;
