% main program to run the demo of Gibbs sampling for LDA learning
%
% Copyright (C) 2009 Xiaodong Yu, xdyu at umiacs umd edu;
% distributable under GPL, see README.txt
clc;
clear all;
close all;

%%  data 
gen_images;

%% Gibbs̿ LDA н
load 'demo_data.mat';
max_iter       = 20; %1000;
burn_in_iter   = 10; %100;
sampling_lag   = 5;  %50;
plot_flag      = 1;
plot_phi_sizes = [4 4];

%%
[est_Phi, est_Theta, logPw_z, est_Phi2, est_Theta2] ...
    = learn_GibbsLDA(w, K, alpha, beta, 1000, 100, 50, 1, [4 4]);

%% phi w ؼ topicҴϸ ǳ? ׷  ƴϸ   eq 2.20
save('lda_result_data.mat','est_Phi','est_Theta','logPw_z', 'est_Phi2','est_Theta2' ...
    , 'K', 'sampling_lag', 'max_iter', 'plot_phi_sizes');

%% Load and plot
load('lda_result_data.mat');

%%
figure(1); clf;
colormap 'gray'
for k = 1:K
    subplot(2, K/2, k);
    imagesc(reshape(est_Phi(:,k), plot_phi_sizes)); axis equal; axis tight; axis off;
    title(['Topic \theta_' num2str(k)])
end;
fig_fname = 'pics/lda_final_topics.png';
print('-dpng', fig_fname);

%% show the history of log likelihood, log(w|z), solid red dots
% corresponding to the iterations when the figures
figure(2); clf;
plot(logPw_z,'b-');
hold on;
plot(sampling_lag:sampling_lag:max_iter, ...
    logPw_z(sampling_lag:sampling_lag:max_iter),'ro',...
    'MarkerSize', 10, 'MarkerFaceColor', 'r');
xlabel('iterations'); ylabel('log(P(w|z))');
print('-dpng', 'pics/logPw_z.png');

%%

